﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace NOKIA_LCD_UTILITY
{
    public partial class Form1 : Form
    {
        private Bitmap BitmapImage;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BitmapImage = new Bitmap(132, 132);
            for (byte i = 0; i < 132; i++)
                for (byte j = 0; j < 132; j++)
                    BitmapImage.SetPixel(i, j, Color.White);
            pictureBox1.Image = BitmapImage;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            if (openFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                try
                {
                    Image x = Image.FromFile(openFileDialog1.FileName);
                    BitmapImage = new Bitmap(x, new Size(132, 132));
                    pictureBox1.Image = BitmapImage;
                }
                catch (Exception)
                {
                    MessageBox.Show("WRONG IMAGE", "NOKIA LCD UTILITY", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Color RGB;
            int R, G, B, FINAL_COLOR;
            if (saveFileDialog1.ShowDialog() != DialogResult.Cancel)
            {
                FileStream f = new FileStream(saveFileDialog1.FileName, FileMode.Create, FileAccess.Write);
                StreamWriter writer = new StreamWriter(f);
                writer.Write("const unsigned int ImageName[132][132]={");
                for (int row = 0; row < 132; row++)
                {
                    writer.Write("{");
                    for (int col = 0; col < 132; col++)
                    {
                        RGB = BitmapImage.GetPixel(col, row);
                        R = RGB.R * 15 / 255;
                        G = RGB.G * 15 / 255;
                        B = RGB.B * 15 / 255;
                        FINAL_COLOR = (B<<8);
                        FINAL_COLOR = FINAL_COLOR | (R << 4);
                        FINAL_COLOR = FINAL_COLOR | G;
                        writer.Write(FINAL_COLOR.ToString());
                        if(col%5==0)writer.WriteLine();
                        if (col != 132 - 1) writer.Write(",");
                    }
                    writer.Write("}");
                    if (row != 132 - 1) writer.Write(",");
                }
                writer.WriteLine("};");
                writer.Close();
                f.Close();
            }
            saveFileDialog1.FileName = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            for (byte i = 0; i < 132; i++)
                for (byte j = 0; j < 132; j++)
                    BitmapImage.SetPixel(i, j, Color.White);
            pictureBox1.Image = BitmapImage;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (saveFileDialog2.ShowDialog() != DialogResult.Cancel)
            {
                FileStream fs = new FileStream(saveFileDialog2.FileName, FileMode.Create, FileAccess.Write);
                Color RGB;
                int R, G, B;
                int FINAL_COLOR;
                byte[] b;
                b = new byte[2];
                for (byte i = 0; i < 132; i++)
                {
                    for (byte j = 0; j < 132; j++)
                    {
                        RGB = BitmapImage.GetPixel(i, j);
                        R = RGB.R * 15 / 255;
                        G = RGB.G * 15 / 255;
                        B = RGB.B * 15 / 255;
                        FINAL_COLOR = (B << 8);
                        FINAL_COLOR = FINAL_COLOR | (R << 4);
                        FINAL_COLOR = FINAL_COLOR | G;
                        b[0] = (byte)((FINAL_COLOR & 0xff00) >> 8);
                        b[1] = (byte)((FINAL_COLOR & 0x00ff));
                        fs.Write(b, 0, b.Length);
                    }
                }
               
                fs.Close();
            }
            saveFileDialog2.FileName = "";
        }

        private void button6_Click(object sender, EventArgs e)
        {
            MessageBox.Show("DEVELOPED BY NART SCHINACKOW\r\nLIBSTOCK USER : NART_SCHINACKOW", "NOKIA LCD UTILITY", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
    }
}
